unit commdefs;

{*******************************************************}
{                                                       }
{       Jana 2 Remote Class                             }
{       Communication structures for                    }
{       Jana Server 2                                   }
{                                                       }
{       Copyright (c) T.Hauck                           }
{                                                       }
{       Translator: Ulf Schaper                         }
{                                                       }
{*******************************************************}

interface


type
  TCPAnfragen = (ssTcpInfo);

(*

 Jana Quellcode Stand 20.11.2001:

 enum {
   DISCOVER = 1,   // Broadcast for Ip-Adress of Server
   RASSTATUS,    // Status of Ras connection
   NUMCONNECTIONS,   // Nr of Connections
   MAILPICKUP,    // Start Mailpickup
   TERMRAS,    // Terminate Ras Connection
   LOCKRAS,    // Look Ras Connection
   ISRASLOCK,    // Is Ras Connection looked
   CONFIGPORT,    // Portnumber for Configuration
   SHUTDOWN = 99   // Shutdown Server
 }
*)

type
  UDPAnfragen = (
                 ssUdpLeer0,
                 ssUpdDiscover,      {1}
                 ssUdpRasState,      {2}
                 ssUdpNumConns,      {3}
                 ssUdpMail,          {4}
                 ssUdpDisconnect,    {5}
                 ssUdpLock,          {6}
                 ssUdpLockState,     {7}
                 ssUdpConfigPort,    {8}
                 ssUdpLeer9, ssUdpLeer10, ssUdpLeer11, ssUdpLeer12, ssUdpLeer13, ssUdpLeer14, ssUdpLeer15, ssUdpLeer16, ssUdpLeer17, ssUdpLeer18, ssUdpLeer19,
                 ssUdpLeer20, ssUdpLeer21, ssUdpLeer22, ssUdpLeer23, ssUdpLeer24, ssUdpLeer25, ssUdpLeer26, ssUdpLeer27, ssUdpLeer28, ssUdpLeer29,
                 ssUdpLeer30, ssUdpLeer31, ssUdpLeer32, ssUdpLeer33, ssUdpLeer34, ssUdpLeer35, ssUdpLeer36, ssUdpLeer37, ssUdpLeer38, ssUdpLeer39,
                 ssUdpLeer40, ssUdpLeer41, ssUdpLeer42, ssUdpLeer43, ssUdpLeer44, ssUdpLeer45, ssUdpLeer46, ssUdpLeer47, ssUdpLeer48, ssUdpLeer49,
                 ssUdpLeer50, ssUdpLeer51, ssUdpLeer52, ssUdpLeer53, ssUdpLeer54, ssUdpLeer55, ssUdpLeer56, ssUdpLeer57, ssUdpLeer58, ssUdpLeer59,
                 ssUdpLeer60, ssUdpLeer61, ssUdpLeer62, ssUdpLeer63, ssUdpLeer64, ssUdpLeer65, ssUdpLeer66, ssUdpLeer67, ssUdpLeer68, ssUdpLeer69,
                 ssUdpLeer70, ssUdpLeer71, ssUdpLeer72, ssUdpLeer73, ssUdpLeer74, ssUdpLeer75, ssUdpLeer76, ssUdpLeer77, ssUdpLeer78, ssUdpLeer79,
                 ssUdpLeer80, ssUdpLeer81, ssUdpLeer82, ssUdpLeer83, ssUdpLeer84, ssUdpLeer85, ssUdpLeer86, ssUdpLeer87, ssUdpLeer88, ssUdpLeer89,
                 ssUdpLeer90, ssUdpLeer91, ssUdpLeer92, ssUdpLeer93, ssUdpLeer94, ssUdpLeer95, ssUdpLeer96, ssUdpLeer97, ssUdpLeer98,
                 ssUdpServerShutdown  {99}
                );

const
  cs_offline = 0;
  cs_online  = 1;
  cs_error   = 2;
  cs_dailing = 3;
  cs_locked  = 4;  

  ls_locked   = 1;
  ls_unlocked = 0;



(*

  Jana Quellcode Stand 20.11.2001:
   typedef struct tagRemoteRequest
   {
    unsigned short sRequestId; // Request Identifier
    char cCmd;     // Command what Info to return or Command to execute
   }REMOTEREQUEST, *PREMOTEREQUEST;
*)

type tagRemoteRequest = packed record
     sRequestId : word;
     cCmd : byte;
   end;


(* Jana Quellcode Stand 20.11.2001:
   typedef struct tagRemoteAnswer
   {
    unsigned short sRequestId; // Request Identifier
    char Status;    // Antwort Status 0 = Error, 1 = OK
    char DataSize;    // Bytes in Data
    char Data[1];    // Data can be up to 252 Bytes long
   }REMOTEANSWER, *PREMOTEANSWER;
*)

type tagRemoteAnswer = packed record
  sRequestId : word;
  Status : byte;
  DataSize : byte;
  Data : array[0..251] of Char;
 end;

(*
  Und wieder etwas Jana-Quelltext, Stand: 18.11.01

#pragma pack(1)
 typedef struct tagStatus
 {
  int iType; // Type 1 = Status
  int iNrConnections;
  int iTotalRasTime;
  int iTimeUntilDisconnect;
  int iBytesInString;
  char caRasIp[16];
 }STATUS, *PSTATUS;
 *)

const tagStatusIType = 1;
type tagStatus = packed record
  iType : integer;   // =1
  rNrConnections : integer;
  iTotalRasTime : integer;
  iTimeUntilDisconnect : integer;
  iBytesInString : integer;
  caRasIP : array [0..15] of Char;
end;

(*

Jana-Quelltext, Stand: 18.11.01

 typedef struct tagLog
 {
  int iType; // Type 2 = Log
  int iNrOfStrings;
  char caStrings[504];
 }LOG, *PLOG;
#pragma pack()
*)

const tagLogIType = 2;
type tagLog = packed record
  iType : integer; // = 2
  iNrOfStrings : integer;
  caStrings : array[0..503] of char;
end;

function FourBytesSwap(old:integer):integer;

implementation
 uses Sysutils,dialogs;

function FourBytesSwap(old:Longint):Longint;
var m:array[0..3]of byte absolute old;
begin
 result := (m[3]*1) or (m[2]*1*256) or (m[1]*1*256*256) or (m[0]*1*256*256*256);
end;


end.
